#pragma once
#ifndef ADAPTIVE_SAMPLING_TRACER_H_
#define ADAPTIVE_SAMPLING_TRACER_H_

#include <ConcurrentQueue.h>
#include <Pixel.h>
#include <RayTracer.h>

struct PixelBlock
{
    int fromX, toX, fromY, toY;
};

class AdaptiveSamplingTracer : public RayTracer
{
public:
    AdaptiveSamplingTracer(Camera camera, Color24 * image, unsigned int * sampleCountImage)
        : RayTracer(camera, image, sampleCountImage) { }
    virtual ~AdaptiveSamplingTracer() { }
    void operator()();
    void FirstPass();
    void SecondPass();
    void BuildQueue();
private:
};

#endif