#pragma once
#ifndef RAY_TRACER_H_
#define RAY_TRACER_H_

#pragma warning (push, 1)
#include <scene.h>
#pragma warning (pop)
#include <Pixel.h>

class RayTracer
{
public:
    RayTracer(Camera camera, Color24 * image, unsigned int * sampleCountImage)
        : camera_(camera), image_(image), sampleCountImage_(sampleCountImage) { }
    virtual ~RayTracer() { }

protected:
    Color24 * image_;
    unsigned int * sampleCountImage_;
    Camera camera_;

    void DoRayTrace(const Camera & cam, Pixel & pixel, SubPixel & subpix);
    Color DoRayTrace2nd(const Camera & cam, Pixel & pixel, SubPixel & subpix);

    // Make a ray from the camera's center to point (x, y) on the screen. x is from 0 to width - 1, y is from 0 to height - 1.
    // rx and ry is from 0 to 1, indicating where the subpixel is in this pixel.
    // if rx and ry = 0.5, this subpixel is at the center of the pixel.
    Ray GetCameraRay(const Camera & cam, int imgWidth, int x, int y, float rx, float ry);
};

bool TraceRay(const Ray & ray, const Node * node, HitInfo & hitInfo, int hitSide);

#endif