#pragma once
#ifndef COMMON_H_
#define COMMON_H_

const float PI = 3.14159265359f;
const float TWO_PI = PI * 2.0f;
const float HALF_PI = PI * 0.5f;

struct ImagePlane
{
    Point3 topLeft;
    Point3 right;
    Point3 down;
    float width, height;
};

template <typename T>
inline T DegreeToRadian(T x)
{
    return 0.0174533f * x;
}

template <typename T>
T lexical_cast(const std::string& str)
{
    T var;
    std::istringstream iss;
    iss.str(str);
    iss >> var;
    // deal with any error bits that may have been set on the stream
    return var;
}

template <typename T>
inline T Square(T val)
{
    return val * val;
}

#endif